#ifndef __DIGIDOC_ZIP_H__
#define __DIGIDOC_ZIP_H__
//==================================================
// FILE:	BDocZip.h
// PROJECT:     Digi Doc
// DESCRIPTION: Digi Doc functions for zip operations.
// AUTHOR:  Ants Madisson, Business IT Partner
//==================================================
// Copyright (C) AS Sertifitseerimiskeskus
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// GNU Lesser General Public Licence is available at
// http://www.gnu.org/copyleft/lesser.html
//==========< HISTORY >=============================
//      20.02.2008      Ants Madisson
//                      Creation
//==================================================


#ifdef  __cplusplus
extern "C" {
#endif

  //--------------------------------------------------
  EXP_OPTION int deleteFileFromZIP(const char* zip_name, const char* del_file);
  EXP_OPTION int makeDfZIP(const char* zip_name, const char* tmp_name);
  EXP_OPTION int makeDfZIP2(const char* zip_name);
  EXP_OPTION int addFileToZip(const char* filename_try, const char* filename, const char* filenameinzip, int opt_overwrite, char* memBuf);

  EXP_OPTION int do_extract_onefile(const char* zipfilename,const char* filenameinzip, int opt_overwrite, const char* filename);

  EXP_OPTION int do_extract_filemem(const char* zipfilename,const char* filename, DigiDocMemBuf* pBuf);
  EXP_OPTION int calculateFileDigestAndSizeZip(const char* zipfilename,const char* filename, DigiDocMemBuf* size, byte* digest, int len);
  EXP_OPTION int calculateFileDigestFromZip(const char* zipfilename,const char* filename, byte* digest, int method, int len);
  EXP_OPTION int calculateFileSizeFromZip(const char* zipfilename,const char* filename);

  EXP_OPTION int checkFilesInList(const char* zip_name, const char* fileNames);
#ifdef  __cplusplus
}
#endif


#endif // __DIGIDOC_ZIP_H__
